#!/usr/bin/env ruby
require 'rinda/ring'
require 'rinda/tuplespace'
require 'tmpdir'

class JukeboxServer
  def initialize
    @play_list = Rinda::TupleSpace.new
  end

  def play
    puts "waiting..."
    name, music_file = @play_list.take([:music, nil])
    puts "playing..."
    system "mpg123 #{music_file}"
    File.delete "#{Dir.tmpdir}/#{music_file}"
  end

  def request(file_name, music_data)
    open("#{Dir.tmpdir}/#{file_name}", "w") {|f| f.write music_data }
    @play_list.write([:music, "#{Dir.tmpdir}/#{file_name}"])
  end
end

jukebox_server = JukeboxServer.new
DRb.start_service(nil, jukebox_server)

provider = Rinda::RingProvider.new(:jukebox, DRbObject.new(jukebox_server), 'Jukebox Server')
provider.provide

loop { jukebox_server.play }

DRb.thread.join
